#!/usr/bin/perl
#
### ADMIN SCRIPT FOR ULTIMATE GUESTBOOK ##
#
# Ultimate Guestbook is copyright Madrona Park, Inc.
#
# User assumes all liability that
# may result due to installation problems and/or
# content posted on your guestbook.  User must also 
# keep all copyright notices on applicable pages.  
#
# For more info on the Ultimate Guest Book, 
# see http://www.scriptkeeper.com
#
#For info on Madrona Park, Inc, see http://www.madronapark.com
################################################################

print ("Content-type: text/html\n\n");

eval {
  ($0 =~ m,(.*)/[^/]+,)   && unshift (@INC, "$1"); # Get the script location: UNIX / or Windows /
  ($0 =~ m,(.*)\\[^\\]+,) && unshift (@INC, "$1"); # Get the script location: Windows \
 
#substitute all require files here for the file

require "gb_variables.pl";
require "ugb_lib.pl";
require "gb_styles.pl";
};

if ($@) {
    print "Error including required files: $@\n";
    print "Make sure these files exist, permissions are set properly, and paths are set correctly.";
 exit;
}

&ReadParse;

$action = $in{'action'};

if ($action eq "edit") {
	&Edit;
}
if ($action eq "styles") {
   &Styles;
}
if ($action eq "genvars") {
   &GenVars;
}
if ($action eq "setgenvars") {
	&SetGenVars;
}
if ($action eq "enterstyles") {
   &EnterStyles;
}
if ($action eq "enteredit") {
   &EnterEdit;
}
if ($action eq "sendstyles") {
   &SendStyles;
}
if ($action eq "entergenvar") {
   &EnterGenVar;
}
if ($action eq "env") {
   &Env;
}
if ($action eq "mdelete") {
   &MDelete;
}
if ($action eq "deleteentry") {
   &DeleteEntry;
}

sub DeleteEntry {
&ValidatePW;

@entries = &OpenFile("$GB_NON_CGI_Path/entries.file");

foreach $uno(@entries) {
@thisline = split(/\|\|/, $uno);
chomp($thisline[6]);
unless ($thisline[6] eq "$in{'number'}") {
	push(@revised, $uno);
}
}

&Lock("lock.file");
open(REVISED, ">$GB_NON_CGI_Path/entries.file");
foreach $one(@revised) {
chomp($one);
print REVISED "$one\n";
}
close(REVISED);
&Unlock("lock.file");

#send onscreen confirmation

print<<ForwardHTML;
<HTML><HEAD>
<title>$GBTitle</title>
<meta http-equiv="Refresh" content="2; URL=$CGIURL/ugb.cgi">
</HEAD>
 <BODY $BGColor $PageBackground text="$TextColor" link="$LinkColor" alink="$ActiveLinkColor" vlink="$VisitedLinkColor">
<br><br>
<center>
<table border=0 width=$TableWidth>
<TR>
<TD>
<FONT SIZE="$TextSize" FACE="$FontFace">
<B>Thank you!  We have deleted the guestbook entry you specified.  You are now being taken back to the guestbook automatically.  Please wait two seconds.
<P>
</font>
<FONT SIZE="1" FACE="$FontFace">
<A HREF="$CGIURL/ugb.cgi">Click here if you do not want to wait any longer (or if your browser does not automatically forward you).</A>
</B><br><br>
</FONT>
</td></tr>
</table>
</center>
</body></html>
ForwardHTML

}

sub MDelete {
&StandardHTML("This feature is coming soon.  You can delete individual entries from the guestbook itself.");
}
sub EnterEdit {
&ValidatePW;

$PageTitle = "Delete a Guestbook Entry";
&HEADERHTML;

print<<THIS;
<FORM ACTION="gbadmin.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="deletenumber">
Enter the ID Number of the guestbook entry you would like to delete.
<P>
ID Number: <INPUT TYPE="TEXT" NAME="IDNumber" SIZE=5 MAXLENGTH=10>
<INPUT TYPE="SUBMIT" NAME="SUBMIT" VALUE="Submit Now">

</form>
<P>
<BR><BR>
<center>
<A HREF="http://www.madronapark.com/ugb">Ultimate Guestbook</A>, Version 1.0<BR>
&copy; <A HREF="http://www.madronapark.com">Madrona Park, Inc.</A>, 1999.
</center>
</font>
</body></html>
THIS

}  #end Enter Edit

sub ValidatePW {
if ($in{'setpw'} ne "true") {
&CheckPW;
if ($check ne "true") {
	&StandardHTML("You did not enter valid passwords.  Please use your back button to try again.");
exit;
}
}
}

sub EnterGenVar {
if ($CopyrightWording ne "") {
	$CopyrightWording = &UnHTML($CopyrightWording);
}
if ($AddEntryInfo ne "") {
	$AddEntryInfo = &UnHTML($AddEntryInfo);
}
if ($IntroText ne "") {
	$IntroText = &UnHTML($IntroText);
}
if ($ConfirmAddWording ne "") {
	$ConfirmAddWording = &UnHTML($ConfirmAddWording);
}


$Password1 = $in{'password1'};
$Password2 = $in{'password2'};

&ValidatePW;

if ($GB_CGI_Path eq "") {
	@cgipath = split(/\//, $ENV{'SCRIPT_FILENAME'});
	pop(@cgipath);
	$GB_CGI_Path = join("\/", @cgipath);
	$VariablesPath = $GB_CGI_Path;
}
if ($GB_NON_CGI_Path eq "") {
	$GB_NON_CGI_Path = "$ENV{'DOCUMENT_ROOT'}/uguestbook";
}

if ($NonCGIURL eq "") {
	$NonCGIURL = "http://$ENV{'HTTP_HOST'}/uguestbook";
	$CGIURL = "http://$ENV{'HTTP_HOST'}/cgi-bin";
	$BBEmail = "$ENV{'SERVER_ADMIN'}";
}

if ($Censor eq "ON") {
	$CensorON = "CHECKED";
}  else {
	$CensorOFF = "CHECKED";
}	

if ($TimeFormat eq "24HR") {
	$Time24HR = "CHECKED";
}  else {
	$TimeAMPM = "CHECKED";
}		
if ($DateFormat eq "Euro") {
	$DateEuro = "CHECKED";
}
elsif ($DateFormat eq "EuroExpanded") {
		$DateEuroX = "CHECKED";
}
elsif ($DateFormat eq "USExpanded") {
		$DateUSX = "CHECKED";
}  else {
	$DateUS = "CHECKED";
}
if ($Field2Hyper eq "Email") {
	$F2HyperEmail = "CHECKED";
}
elsif ($Field2Hyper eq "URL") {
		$F2HyperURL = "CHECKED";
}  else {
	$F2HyperNone = "CHECKED";
}
if ($Field3Hyper eq "Email") {
	$F3HyperEmail = "CHECKED";
}
elsif ($Field3Hyper eq "URL") {
		$F3HyperURL = "CHECKED";
}  else {
	$F3HyperNone = "CHECKED";
}
if ($HTMLAllow eq "yes") {
	$HTMLyes = "CHECKED";
}  else {
	$HTMLno = "CHECKED";
}
if ($UBBCodeAllow eq "yes") {
	$UBBCodeyes = "CHECKED";
}  else {
	$UBBCodeno = "CHECKED";
}
$PageTitle = "Set General Variables";
&HEADERHTML;

print<<THIS;
To check your environmental variables, <A HREF="gbadmin.cgi?action=env">click here</A>.
<P>
<FORM ACTION="gbadmin.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="setgenvars">
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">absolute paths</FONT></B>
</TD></TR>
<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Absolute paths reflect the physical locations of directories on a server.  They are the complete locations, not the locations from the web root, but from the server root.  Absolute paths on Win32/NT servers are displayed differently than on UNIX systems.  For instance, note the following samples for UNIX and NT:
<p>
For UNIX servers:  &nbsp;&nbsp;&nbsp;&nbsp;<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#FF0000">/usr/home/yourdomain/www/cgi-bin</font>
<BR>
For Win32/NT servers:&nbsp;&nbsp;&nbsp;&nbsp; <FONT SIZE="1" FACE="Verdana, Arial" COLOR="#FF0000">C:/home/yourdomain/cgi-bin</FONT>
<P>
Note: the paths listed above are examples, not your actual paths.
<P>
If you are installing on Win32/NT, be sure to use the format above for your absolute paths (note the forward slashes, rather than backward slashes).
<BR>
If you are installing for the first time, the Ultimate Guestbook will attempt to provide complete or partial absolute paths for you.  These paths may not be accurate or complete, but they will give you a headstart.  All absolute path fields MUST be provided for your UBB to run.</B></FONT>
</td></tr>
<tr bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Absolute Path for your Ultimate Guestbook CGI DIRECTORY</B><br></FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="GB_CGI_Path" VALUE="$GB_CGI_Path" SIZE=40 MAXLENGTH=250>
</td></tr>

<tr bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Absolute Path of your Ultimate Guestbook NON CGI Directory</B><br></FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="GB_NON_CGI_Path" VALUE="$GB_NON_CGI_Path" SIZE=40 MAXLENGTH=250>
</td></tr>


<tr bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Absolute Path to Directory Where Your Custom Variable Files Reside</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080"><B>You should use the same absolute path that you used for your CGI directory above</B>.  If for some reason you cannot write to files in your CGI directory, however, you should place these files (gb_variables.pl and gb_styles.pl) in a directory below the web root so that they cannot be accessed by anyone from the browser. </FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="VariablesPath" VALUE="$VariablesPath" SIZE=40 MAXLENGTH=250>
</td></tr>
</table>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">URLs</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Please provide the following complete hyperlinks.  Use complete hyperlinks, such as http://www.yourdomain.com/cgi-bin, rather than relative links such as "/cgi-bin"</B></FONT>
</td></tr>

<tr bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>URL for your Ultimate Guestbook  CGI Directory</B><br></FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="CGIURL" VALUE="$CGIURL" SIZE=40 MAXLENGTH=250>
</td></tr>

<tr bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>URL for your Ultimate Guestbook Non-CGI Directory</B><br></FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="NonCGIURL" VALUE="$NonCGIURL" SIZE=40 MAXLENGTH=250>
</td></tr>
</table>
<P>

<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">Display Options</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Please complete the following fields, which provide information such as your Guestbook Name, links, the email address to be displayed, headers and footers to use on each page, etc.</B></FONT>
</td></tr>

<TR bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Your Email Address</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This is email address that will be shown so that users can contact you</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="BBEmail" VALUE="$BBEmail" SIZE=30 MAXLENGTH=250>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Name of Your Guestbook</B><br></FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="GBTitle" VALUE="$GBTitle" SIZE=30 MAXLENGTH=250>
</td></tr>

<TR bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Link #1 Name</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You can have two links that appear at the bottom of most guestbook pages.  These links could be anything you like- your homepage, another area of your website, an outside link, etc.  Type the name of the first link.</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="Link1Name" VALUE="$Link1Name" SIZE=30 MAXLENGTH=250>
</td></tr>
<TR bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Link #1 URL</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Type the complete URL for Link #1 (as in "http://www.cnn.com").</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="Link1URL" VALUE="$Link1URL" SIZE=30 MAXLENGTH=250>
</td></tr>


<TR bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Link #2 Name</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You can have two links that appear at the bottom of most guestbook pages.  These links could be anything you like- your homepage, another area of your website, an outside link, etc.  Type the name of the second link.</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="Link2Name" VALUE="$Link2Name" SIZE=30 MAXLENGTH=250>
</td></tr>
<TR bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Link #2 URL</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Type the complete URL for Link #2 (as in "http://www.cnn.com").</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="Link2URL" VALUE="$Link2URL" SIZE=30 MAXLENGTH=250>
</td></tr>

<TR bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Introduction Text</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This text will appear on your primary guestbook summary page- the first page that visitors to your guestbook see.  This wording should introduce your guestbook and encourage them to add an entry to it.</FONT>
</td>
<td width=50% valign=top>
<TEXTAREA NAME="IntroText" WRAP=VIRTUAL ROWS=5 COLS=30>$IntroText
</TEXTAREA>
</td></tr>


<TR bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Add Entry Text</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This text will appear on "Add Entry" page.  You can customize your wording in the field to the right.</FONT>
</td>
<td width=50% valign=top>
<TEXTAREA NAME="AddEntryIntro" WRAP=VIRTUAL ROWS=5 COLS=30>$AddEntryIntro
</TEXTAREA>
</td></tr>

<TR bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Add Entry Submit Button Wording</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This text will appear on the submit button on the "Add Entry" page.  You can customize your wording in the field to the right.</FONT>
</td>
<td width=50% valign=top><INPUT TYPE="TEXT" NAME="AddSubmitWording" VALUE="$AddSubmitWording" SIZE=25 MAXLENGTH=40>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Confirm New Entry Text</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This text will appear after someone adds a new entry to your guestbook.  You can customize your wording in the field to the right.</FONT>
</td>
<td width=50% valign=top>
<TEXTAREA NAME="ConfirmAddWording" WRAP=VIRTUAL  ROWS=5 COLS=30>$ConfirmAddWording
</TEXTAREA>
</td></tr>

<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Header</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You can add your own customized header graphic, ad banner, text, etc.  This header will appear at the top of each primary UBB page.  This is completely optional.  Leave this field blank if you don't need to use it.</FONT>
</td>
<td width=50% valign=top>
<TEXTAREA NAME="Header" COLS="30" ROWS="5" WRAP="VIRTUAL">$Header</TEXTAREA>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Footer</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You can add your own customized footer graphic, ad banner, text, etc.  This header will appear near the bottom of each primary UBB page.  This is completely optional.  Leave this field blank if you don't need to use it.</FONT>
</td>
<td width=50% valign=top>
<TEXTAREA NAME="Footer" COLS="30" ROWS="5" WRAP="VIRTUAL">$Footer</TEXTAREA>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Your Copyright Wording</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This wording will appear in smaller print directly above the copyright wording concerning the UBB program itself. You can leave this blank or provide any wording you like.</FONT>
</td>
<td width=50% valign=top>
<TEXTAREA NAME="CopyrightWording" ROWS=3 COLS=30 WRAP="VIRTUAL">$CopyrightWording
</TEXTAREA>
</td></tr>
</table>
<P>
<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">Date/Time Display Options</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>The UBB can display dates and times in a number of different formats.  Remember that the times listed are based on the location of your web server, which may be different than the time zone where you reside/work.  You can change the time zone displayed by using the Time Zone Offset field.  For instance, if you are on the East Coast of the US, but your server is on the West Coast of the US, you could use EST as your Time Zone to display, but you would have to offset the server time to reflect that (by typing a 3 in the Time Zone Offset field, reflecting the 3 hours difference).  If the Time Zone difference is negative, use a begative number (as in -2).</B></FONT>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Time Zone</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">The time of each posting is based on the time zone where your server is located.  If you want your users to know the time zone, provide it here (e.g., ET, CT, PT, etc.).  You may also leave this blank if you would prefer not to show a time zone.  You may type a different time zone than your server uses, but if you do so be sure to provide a time zone offset in the next field.</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="TimeZone" VALUE="$TimeZone" SIZE=20 MAXLENGTH=35>
</td></tr>


<TR bgcolor="#dedfdf">
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Server Time Zone Offset</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You can offset the time drawn from your web server.  For instance, if your server time is EST (US), but you want all time to reflect Pacific Time (US), you would have to offset your server time by placing the time zone difference in this field (for this example, that would be -3.  You would place -3 in this field).  The default is for there to be no server time zone offset (0).</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="TimeZoneOffset" VALUE="$TimeZoneOffset" SIZE=3 MAXLENGTH=4>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Date Format</B><BR></FONT>

</td>
<td width=50%>
<FONT SIZE="1" FACE="Verdana, Arial">
<INPUT TYPE="RADIO" NAME="DateFormat" VALUE="US" $DateUS> US Format (Month-Day-Year, as in 04-02-1998)<BR>
<INPUT TYPE="RADIO" NAME="DateFormat" VALUE="USExpanded" $DateUSX> US Expanded Format (Month Day, Year; as in April 2, 1998)<BR>
<INPUT TYPE="RADIO" NAME="DateFormat" VALUE="Euro" $DateEuro> European Format (Day-Month-Year, as in 02-04-1998)<BR>
<INPUT TYPE="RADIO" NAME="DateFormat" VALUE="EuroExpanded" $DateEuroX> European Expanded Format (Month Day, Year; as in 2 April 1998)<BR>
</font>
</td></tr>
<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Time Format</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You can have time displayed in AM/PM format, or in 24-hour format.</FONT>
</td>
<td width=50%>
<FONT SIZE="2" FACE="Verdana, Arial">
<INPUT TYPE="RADIO" NAME="TimeFormat" VALUE="AMPM" $TimeAMPM> Use AM/PM Time Format<BR>
<INPUT TYPE="RADIO" NAME="TimeFormat" VALUE="24HR" $Time24HR> User 24-Hour Format Time (eg, 23:15)
</font>
</td></tr>
</table>
<P>

<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">Guestbook Fields</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>With the Ultimate Guestbook, you can set up to four input fields.  Only the first and fourth fields are required.  The second and third fields are optional.</B></FONT>
</td></tr>
<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Field 1</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This field is REQUIRED.  This is typically the guestbook writer's NAME, but you can change the field to represent something else, if you prefer.  Or perhaps you would rather refer to the field as "Author"... change it if you like in the field to the right.  You can also set the field size and maximum field size for this field.  Set those to the right as well, or leave the defaults.  Note: if you leave these fields blank, the Ultimate Guestbook will assign the default settings for this field.</FONT>
</td>
<td width=50% valign=top>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Field #1 Name: <INPUT TYPE="TEXT" NAME="Field1" VALUE="$Field1" SIZE=25 MAXLENGTH=50><BR>
Field #1 Size: <INPUT TYPE="TEXT" NAME="Field1Size" VALUE="$Field1Size" SIZE=2 MAXLENGTH=3><BR>
Field #1 Maximum Size: <INPUT TYPE="TEXT" NAME="Field1MaxSize" VALUE="$Field1MaxSize" SIZE=2 MAXLENGTH=3></B></FONT>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Field 2</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This field is OPTIONAL.  This is typically the guestbook writer's Email address, but you can change the field to represent something else, if you prefer.  Leave the field blank if you do not wish to use this field.  Set this field's properties to the right.</FONT>
</td>
<td width=50% valign=top>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Field #2 Name: <INPUT TYPE="TEXT" NAME="Field2" VALUE="$Field2" SIZE=25 MAXLENGTH=50><BR>
Field #2 Size: <INPUT TYPE="TEXT" NAME="Field2Size" VALUE="$Field2Size" SIZE=2 MAXLENGTH=3><BR>
Field #2 Maximum Size: <INPUT TYPE="TEXT" NAME="Field2MaxSize" VALUE="$Field2MaxSize" SIZE=2 MAXLENGTH=3>
<P>
We will automatically add hyperlinks if this field is an email address or URL.  Please select one of the following:</B>
<BR>
<INPUT TYPE="RADIO" NAME="Field2Hyper" VALUE="email" $F2HyperEmail>
Email<BR>
<INPUT TYPE="RADIO" NAME="Field2Hyper" VALUE="url" $F2HyperURL>
URL<BR><INPUT TYPE="RADIO" NAME="Field2Hyper" VALUE="none" $F2HyperNone>
No Hyperlink
<BR>


</FONT>
</td></tr>


<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Field 3</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This field is OPTIONAL.  This is typically the guestbook writer's URL, but you can change the field to represent something else, if you prefer.  Leave the field blank if you do not wish to use this field.  Set this field's properties to the right.</FONT>
</td>
<td width=50% valign=top>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Field #3 Name: <INPUT TYPE="TEXT" NAME="Field3" VALUE="$Field3" SIZE=25 MAXLENGTH=50><BR>
Field #3 Size: <INPUT TYPE="TEXT" NAME="Field3Size" VALUE="$Field3Size" SIZE=2 MAXLENGTH=3><BR>
Field #3 Maximum Size: <INPUT TYPE="TEXT" NAME="Field3MaxSize" VALUE="$Field3MaxSize" SIZE=2 MAXLENGTH=3>

<P>
We will automatically add hyperlinks if this field is an email address or URL.  Please select one of the following:</B>
<BR>
<INPUT TYPE="RADIO" NAME="Field3Hyper" VALUE="email" $F3HyperEmail>
Email<BR>
<INPUT TYPE="RADIO" NAME="Field3Hyper" VALUE="url" $F3HyperURL>
URL<BR><INPUT TYPE="RADIO" NAME="Field3Hyper" VALUE="none" $F3HyperNone>
No Hyperlink
<BR>
</FONT>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Field 4</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">This field is REQUIRED.  This is a text area, not a text field (for those of you that know HTML).  This is typically the guestbook writer's entry, but you can change the field to represent something else, if you prefer.     Note: if you leave this field blank, the Ultimate Guestbook will assign the default setting for this field.</FONT>
</td>
<td width=50% valign=top>
<FONT SIZE="1" FACE="Verdana, Arial"><B>Field #4 Name: <INPUT TYPE="TEXT" NAME="Field4" VALUE="$Field4" SIZE=25 MAXLENGTH=50></B></FONT>
</td></tr>
</table>
<P>

<table border=0 width=100%>
<TR bgcolor="#000000"><TD COLSPAN=2 align=center><B><FONT SIZE="2" FACE="Verdana, Arial" color="#FFFF00">Miscellaneous Options</FONT></B>
</TD></TR>

<TR bgcolor="#FCF0C0">
<TD colspan=2><FONT SIZE="1" FACE="Verdana, Arial">
<B>Below are numerous configuration options for your UBB.</B></FONT>
</td></tr>
<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Censor Option</B><br></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You may have certain words censored on your guestbook.  Words you choose to censor will be replaced by asterisks. To activate the censor function, check the "yes" button below.  To deactivate, press the "no" button.  List all censored words in the field to the right.</FONT>
<CENTER><FONT SIZE="2" FACE="Verdana, Arial" COLOR="#000080"><INPUT TYPE="RADIO" NAME="Censor" VALUE="ON" $CensorON> yes
<INPUT TYPE="RADIO" NAME="Censor" VALUE="OFF" $CensorOFF> no
</FONT></CENTER>
</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Censor Words</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">Type all words you want censored in the field below.  Do not use commas to separate words, just use spaces.  For example, type "dog cat boy", rather than "dog, cat, boy."  If you type "dog", all words containing the string "dog" would be censored (dogma, for instance, would appear as "***ma").  To censor more accurately, you can require that censors occur only for exact words.  You can do this by placing a censor word in curly braces, as in {dog}.  Signifying "dog" in the curly braces would mean that dogma would appear as dogma, but dog would appear as "***".  Thus your censor list may appear as cat "{dog} {barn} barn."
</FONT><BR>
<TEXTAREA NAME="censorwords" ROWS=3 COLS=30 WRAP="VIRTUAL">$censorwords
</TEXTAREA>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Maximum Entries To Display Per Page</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You can select the number of entries to display per page.  The default (recommended) number is 25.</FONT>
</td>
<td width=50% valign=top>
<INPUT TYPE="TEXT" NAME="MaxDisplay" VALUE="$MaxDisplay" SIZE=2 MAXLENGTH=2>
</td></tr>

<TR bgcolor="#dedfdf">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Allow HTML in Entries?</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">You may allow HTML to be used in guestbook entries, if you desire.  This is NOT recommended, however, because incorrect HTML syntax can cause erratic display of your guestbook pages.</FONT>
</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="HTMLAllow" VALUE="yes" $HTMLyes>
Allow HTML
<BR>
<INPUT TYPE="RADIO" NAME="HTMLAllow" VALUE="no" $HTMLno>
Don't Allow HTML</B></FONT>
</td></tr>

<TR bgcolor="#f7f7f7">
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Allow UBB Code in Entries?</B><BR></FONT>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#000080">UBB Code is a much safer way of allowing people to add hyperlinks, email links, and images to their entries, without using HTML. </FONT>
</td>
<td width=50% valign=top>
<FONT SIZE="2" FACE="Verdana, Arial"><B><INPUT TYPE="RADIO" NAME="UBBCodeAllow" VALUE="yes" $UBBCodeyes>
Allow UBB Code
<BR>
<INPUT TYPE="RADIO" NAME="UBBCodeAllow" VALUE="no" $UBBCodeno>
Don't Allow UBB Code</B></FONT>
</td></tr>
</table>
<P>
<br>
<CENTER><FONT Size="2" FACE="Verdana, Arial" COLOR="#000080"><B>Enter your two passwords:</font>
<P>
<FONT Size="1" FACE="Verdana, Arial" COLOR="#808000">(NOTE: if you are configuring your guestbook for the first time, the passwords you typed on the previous page will be inserted below for you.  Just press on the button below)</font>
<p>
<FONT Size="2" FACE="Verdana, Arial" COLOR="#000080">
Password #1: <INPUT TYPE="PASSWORD" value="$Password1" NAME="password1" SIZE=25 MAXLENGTH=25><BR>Password #2: <INPUT TYPE="PASSWORD" NAME="password2" value="$Password2" SIZE=25 MAXLENGTH=25></FONT></B></CENTER>
<p><center>
<INPUT TYPE="HIDDEN" NAME="setpw" VALUE="$in{'setpw'}">

<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit General Variables"></center>
</form>
</BODY></HTML>
THIS

}  # end EnterGenVar sr

sub GenVars {
$PageTitle = "Set General Variables";
&HEADERHTML;

#check to see if passwords have been set
if (-e "$GB_NON_CGI_Path/gbpassword.pl") {
#if username and password have been set, query for Passwords
&AuthenticateWording("entergenvar");
}  else {
#if passwords have not been set, query user to set them now
&QueryToSetPW;
}
}  ## END genvars SR ##

sub Env {
print<<TOP;
<HTML><BODY BGCOLOR="#FFFFFF">
<CENTER>
<TABLE BORDER=0><TR><TD>
<CENTER><IMG SRC="$NonCGIURL/$GBTitlePic" BORDER=0 ALT="$BBName"></CENTER>
</TD></TR><td>
<FONT FACE="Verdana, Arial" SIZE="3" COLOR="Navy">Your Environmental Variables</FONT></TD></TABLE>
<P>
</CENTER>
<FONT FACE="VERDANA, ARIAL" SIZE="2">
Use these to help you figure out your absolute file paths, and other system information.
<P>
Your Perl Version: <B>$]</B>
<P>
TOP
foreach $envline (%ENV) {
print $envline;
print "<br>\n";
}
print<<BOTTOM;
</FONT></BODY></HTML>
BOTTOM
}  # END ENV SR

sub HEADERHTML {
print<<HEADER;
<HTML>
<HEAD>
	<TITLE>$GBTitle</TITLE></HEAD>
<BODY bgcolor="#FFFFFF" link="#000080" vlink="#808000">
<BR>
<center>
<FONT SIZE="5" FACE="Courier New"><B>$PageTitle</B></FONT>
</center>
<FONT SIZE="2" FACE="Verdana, Arial">
<p>
HEADER
} #end HEADERHTML sr


sub SetGenVars {

#make sure path is correct
if (-e "$in{'GB_NON_CGI_Path'}/frown.gif") {
		if (-e "$in{'GB_NON_CGI_Path'}/gbpassword.pl") {
			&CheckPW;
				if ($check eq "true") {
					&SetVars;
				} else {
&StandardHTML("Sorry, did not enter the correct passwords.  We cannot process your variables until this is corrected.  Use your back button to try again.");
				}
				
		}  else {
		&SetPW;
		&SetVars;
		}
	
}  else {
	&StandardHTML("Sorry, but you do not seem to have entered the correct absolute path for your NON CGI directory.  Your other absolute paths may also be incorrect.  We cannot process your variables until this is corrected.  Use your back button to try again.");
}

}  ##END Set Gen Vars

sub SetVars {
if ($in{'Field1'} eq "") {
	$in{'Field1'} = "Name";
}
if ($in{'Field4'} eq "") {
	$in{'Field4'} = "Guestbook Entry";
}
if ($in{'Field1Size'} eq "") {
	$in{'Field1Size'} = "20";
}
if ($in{'Field1MaxSize'} eq "") {
	$in{'Field1MaxSize'} = "40";
}

open (FILE, ">$in{'VariablesPath'}/gb_variables.pl") or die("Unable to open setup file for writing.");

foreach $one(@in) {
	($Name, $Value) = split ("=", $one);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	$Value =~ s/\@/\\@/g;
	$Value =~ s/"/\\"/g;
	if (($Name eq "AddEntryInfo") || ($Name eq "IntroText") || ($Name eq "ConfirmAddWording"))  {

		$Value = &ConvertReturns($Value);
		$Value =~ s/(<P>)+/<P>/ig;
		
	} else {
		$Value = &EliminateReturns($Value);
	}
	
	print FILE ("\$$Name = \"$Value\";\n");
}

	print FILE ("1;\n");
close (FILE);
chmod (0777, "$in{'VariablesPath'}/gb_variables.pl");

&StandardHTML("Thank you!  Your general variables have been set!  If you are configuring your guestbook for the first time, don't forget to set your style variables as well.");

}  #end Setvars sr


sub SetPW {
$Password1 = &decodeURL($in{'password1'});
$Password2 = &decodeURL($in{'password2'});

open (SETIT, ">$in{'GB_NON_CGI_Path'}/gbpassword.pl");
print SETIT "$Password1\n";
print SETIT "$Password2";
close (SETIT);
chmod (0666, "$in{'GB_NON_CGI_Path'}/gbpassword.pl");

} #end SetPW sr

sub CheckPW {
if (($in{'action'} eq "entergenvar") || ($in{'action'} eq "enterstyles") || ($in{'action'} eq "sendstyles") || ($in{'action'} eq "deleteentry")){
$ThePath = "$GB_NON_CGI_Path";
}  else {
$ThePath = "$in{'GB_NON_CGI_Path'}";
}

open (READIT, "$ThePath/gbpassword.pl");
@pw = <READIT>;
close (READIT);

$Password1 = decodeURL($in{'password1'});
$Password2 = decodeURL($in{'password2'});
chomp($pw[0]);
chomp($pw[1]);

if (($Password1 eq "$pw[0]") && ($Password2 eq "$pw[1]")) {
	$check = "true";
} else {
	$check = "false";
}
}  # end CheckPW sr

sub Styles {
$PageTitle = "Set Style Variables";
&HEADERHTML;

#check to see if passwords have been set
if (-e "$GB_NON_CGI_Path/gbpassword.pl") {
#if username and password have been set, query for Passwords
&AuthenticateWording("enterstyles");
}  else {
#if passwords have not been set, query user to set them now
&QueryToSetPW;
}
}  ## END Styles SR ##


sub Edit {
$PageTitle = "Delete A Guestbook Entry";
&HEADERHTML;

#check to see if passwords have been set
if (-e "$GB_NON_CGI_Path/gbpassword.pl") {
#if username and password have been set, query for Passwords

print<<Threads;
<FONT SIZE="2" FACE="$FontFace" COLOR="#000000">Note: only users knowing this guestbook's passwords may delete this entry.

<P>
If you don't remember your passwords, open the file entitled "gbpassword.pl" in your guestbook NON CGI directory.  The two passwords are listed in that file.
<P>
NOTE: Guestbook Entry Number $in{'number'} will be deleted when you press the submit button below.
<P>
</FONT>
<FORM ACTION="gbadmin.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="deleteentry">
<INPUT TYPE="HIDDEN" NAME="number" VALUE="$in{'number'}">
<table border=0>
<TR>
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Password #1</B></FONT>
</td>
<td><INPUT TYPE="Password" NAME="password1" SIZE=25 MAXLENGTH=25>
</td></tr>
<TR>
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Password #2</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="password2" SIZE=25 MAXLENGTH=25>
</td></tr>
</table>
<p>
<center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Delete The Entry Now!">
</CENTER>
</FORM>
</BODY></HTML>
Threads
}  else {
#if passwords have not been set, query user to set them now
&QueryToSetPW;

}
}  ## END Edit SR ##


sub AuthenticateWording {
my $action = shift;

print<<Threads;
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FF0000">Note: only users knowing this guestbook's passwords may perform this function.

<P>
If you don't remember your passwords, open the file entitled "gbpassword.pl" in your guestbook NON CGI directory.  The two passwords are listed in that file.
<P>
</FONT>
<FORM ACTION="gbadmin.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="$action">
<table border=0>
<TR>
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Password #1</B></FONT>
</td>
<td><INPUT TYPE="Password" NAME="password1" SIZE=25 MAXLENGTH=25>
</td>
<TR>
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Password #2</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="password2" SIZE=25 MAXLENGTH=25>
</td>
</table>
<p>
<center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Enter  Now!">
</CENTER>
</FORM>
</BODY></HTML>
Threads

}


sub QueryToSetPW {
print<<Threads;
<FONT SIZE="2" FACE="Verdana, Arial" COLOR="#FF0000">Welcome!
<P>
To administer your guestbook, you need to set two passwords, which will be used whenever you want to access this control panel area.  By using passwords, you can ensure that no one else can make changes to your guestbook but you (or others you give the passwords to).
<P>
You need to set two passwords.  These passwords can be identical, but we recommend that you set two different words.  These words should contain only letters or numbers.  All passwords are case-sensitive.  This means that if you enter a password of "Wally", "WALLY" will not match it.
<P>
Set your guestbook passwords below!
<P>

<FORM ACTION="gbadmin.cgi" METHOD="POST">
<INPUT TYPE="HIDDEN" NAME="action" VALUE="entergenvar">
<INPUT TYPE="HIDDEN" NAME="setpw" VALUE="true">
Note: You will be directed to the general variables area after you enter your passwords.  Please set your general variables before setting styles.
<P>
<table border=0>
<TR>
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Password #1</B></FONT>
</td>
<td><INPUT TYPE="Password" NAME="password1" SIZE=25 MAXLENGTH=25>
</td>
<TR>
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Password #2</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="password2" SIZE=25 MAXLENGTH=25>
</td>
</table>
<p>
<center>
<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Set Passwords Now!">


</FORM>
<P><BR>
Ultimate Guestbook<BR>&copy; <A HREF="http://www.madronapark.com">Madrona Park, Inc.</A>, 1999.
</CENTER></FONT>
</BODY></HTML>
Threads
} #end QueryToSetPW

sub EnterStyles {
&ValidatePW;

$PageTitle = "Set Style Variables";
&HEADERHTML;

if ($CopyrightTextColor eq "") {
	$CopyrightTextColor = "#C0C0C0";
}

if ($TextSize eq "") {
	$TextSize = "2";
}
if ($FontFace eq "") {
	$FontFace = "Verdana, Arial";
}

if ($TextColor eq "") {
	$TextColor = "#000000";
}
if ($LinkColor eq "") {
	$LinkColor = "#000080";
}
if ($VisitedLinkColor eq "") {
	$VisitedLinkColor = "#808000";
}

if ($TableStripTextColor eq "") {
	$TableStripTextColor = "#000080";
}


if ($GBTitlePic eq "") {
	$GBTitlePic = "ugb.jpg";
}
if ($AddEntryPic eq "") {
	$AddEntryPic = "addentry.jpg";
}
if ($TableWidth eq "") {
	$TableWidth = "95%";
}

if ($PostedByColor eq "") {
	$PostedByColor = "#800000";
}

if ($BGColor eq "") {
	$BGColor = "#FFFFFF";
} else {
	if ($BGColor =~ /=/) {
($junk, $BGColor) = split (/=/, $BGColor);
chomp($BGColor);
	}
}

if ($TableColorStrip eq "") {
	$TableColorStrip = "";
} else {
	if ($TableColorStrip =~ /=/) {
($junk, $TableColorStrip) = split (/=/, $TableColorStrip);
chomp($TableColorStrip);
	}
}


print<<StyleHTML;
<B>
You can easily change the font face and/or color, graphics, and background colors used throughout your guestbook using this control panel page.  Note: these changes affect only the guestbook pages, not any of the control panel pages.  For all colors, we recommend using hexadecimal codes (i.e, #FFFFFF for "white", etc.).
</B>
</FONT>
<P>
<FORM ACTION="gbadmin.cgi" METHOD="POST" NAME="THEFORM">

<table border=0 >
<TR>
<TD colspan=3 bgcolor="#dedfdf">
<FONT FACE="Verdana" SIZE="2"><B>Color Options</B></FONT>
</TD>
</TR>
<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Page Background Color</B><br>
<FONT SIZE="1" FACE="Verdana, Arial" COLOR="#FF0000">Format - #FFFFFF</FONT>
</FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="BGColorChoice" onChange="forms[0].BGColor.value=options[selectedIndex].value">
StyleHTML

&Colors;

print<<Style2;
<INPUT TYPE="TEXT" NAME="BGColor" VALUE="$BGColor" SIZE=7 MAXLENGTH=7>
</td></tr>
<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Text Color</B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="TextColorChoice" onChange="forms[0].TextColor.value=options[selectedIndex].value">
Style2

&Colors;

print<<Style3;
<INPUT TYPE="TEXT" NAME="TextColor" VALUE="$TextColor" SIZE=7 MAXLENGTH=7>
</td></tr>
<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Link Color</B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="LinkColorChoice" onChange="forms[0].LinkColor.value=options[selectedIndex].value">
Style3

&Colors;

print<<Style4;
<INPUT TYPE="TEXT" NAME="LinkColor" VALUE="$LinkColor" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Visited Link Color</B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="VisitedLinkColorChoice" onChange="forms[0].VisitedLinkColor.value=options[selectedIndex].value">
Style4

&Colors;

print<<Style5;
<INPUT TYPE="TEXT" NAME="VisitedLinkColor" VALUE="$VisitedLinkColor" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Table Header Strip Text Color </B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="TableStripColorChoice" onChange="forms[0].TableStripTextColor.value=options[selectedIndex].value">
Style5

&Colors;

print<<Style6;
<INPUT TYPE="TEXT" NAME="TableStripTextColor" VALUE="$TableStripTextColor" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Table Header Strip Background Color</B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="TableColorStripChoice" onChange="forms[0].TableColorStrip.value=options[selectedIndex].value">
Style6

&Colors;

print<<Style7;
<INPUT TYPE="TEXT" NAME="TableColorStrip" VALUE="$TableColorStrip" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>First Alternating Table Row Color</B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="AltRowColor1Choice" onChange="forms[0].AltRowColor1.value=options[selectedIndex].value">
Style7

&Colors;

print<<Style8;
<INPUT TYPE="TEXT" NAME="AltRowColor1" VALUE="$AltRowColor1" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Second Alternating Table Row Color</B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="AltRowColor2Choice" onChange="forms[0].AltRowColor2.value=options[selectedIndex].value">
Style8

&Colors;

print<<Style9;
<INPUT TYPE="TEXT" NAME="AltRowColor2" VALUE="$AltRowColor2" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Copyright Text Color</B><br></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="CopyrightTextColorChoice" onChange="forms[0].CopyrightTextColor.value=options[selectedIndex].value">
Style9

&Colors;

print<<Style11;
<INPUT TYPE="TEXT" NAME="CopyrightTextColor" VALUE="$CopyrightTextColor" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>"Posted" Date/Time Text Color</B><br><FONT SIZE="1" FACE="Verdana, Arial" color="#800000">The color of the text that appears on the Date/Time line for each entry</FONT></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="PostedByColorChoice" onChange="forms[0].PostedByColor.value=options[selectedIndex].value">
Style11

&Colors;

print<<Style11a;
<INPUT TYPE="TEXT" NAME="PostedByColor" VALUE="$PostedByColor" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Table Border Color</B><br><FONT SIZE="1" FACE="Verdana, Arial" color="#800000">You can create a colored border that will surround your tables, if you like.  Leave this field blank if you do not want a colored border.</FONT></FONT>
</td>
<td valign=top NOWRAP>
<SELECT name="TableBorderColorChoice" onChange="forms[0].TableBorderColor.value=options[selectedIndex].value">
Style11a

&Colors;

print<<Style12;
<INPUT TYPE="TEXT" NAME="TableBorderColor" VALUE="$TableBorderColor" SIZE=7 MAXLENGTH=7>
</td></tr>

<tr>
<td bgcolor="#dedfdf"colspan=3><B><FONT FACE="Verdana" SIZE="2">Miscellaneous Graphic Options</FONT></B></TD>
</TR>
<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Font Face (e.g., Verdana)<FONT SIZE="1" FACE="Verdanam, Arial" color="#FF0000"><br>We recommend you use a backup font as well.  For example: to use Verdana as your first choice, with Arial as a conditional font for those users that don't have Verdana as a font on their system, you would type "Verdana, Arial")</FONT></B><br></FONT>
</td>
<td valign=top>
<INPUT TYPE="TEXT" NAME="FontFace" VALUE="$FontFace" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Table Width</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial" color="#FF0000">You may use either exact pixels (recommended: 600) or a percentage (recommended: 90%)</FONT>
</td>
<td valign=top>
<INPUT TYPE="TEXT" NAME="TableWidth" VALUE="$TableWidth" SIZE=5 MAXLENGTH=7>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Text Size</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial" color="#FF0000">We recommend using size 2... but depending on your font face, you may want to alter this.</FONT>
</td>
<td valign=top>
<INPUT TYPE="TEXT" NAME="TextSize" VALUE="$TextSize" SIZE=1 MAXLENGTH=1>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Page Background Graphic</B><br></FONT><FONT SIZE="1" FACE="Verdana, Arial" color="#FF0000">Not recommended to be used, but you can add a background graphic to your pages.  If you do so, you should upload the graphic into your NON CGI directory and place the name of the background graphic in this field.  For example, background.gif.</FONT>
</td>
<td valign=top>
<INPUT TYPE="TEXT" NAME="PageBackground" VALUE="$PageBackground" SIZE=30 MAXLENGTH=200>
</td></tr>
</table>

<P>

<TABLE BORDER=0>
<tr>
<td bgcolor="#dedfdf"colspan=3><B><FONT FACE="Verdana" SIZE="2"> Graphic Images</B>
<P>
Recommended graphic sizes: if you are creating your own graphics, we recommend that the following sizes (in pixels) be used (in order to fit with layout of the BB): <ul>
<LI> Title/logo graphic- 500 wide by 105 high 
<LI> Add Entry graphic - 155 wide by 75 high
</ul><br>
Don't forget: if you are using your own custom graphics instead of one of the standard graphics shown above, be sure to upload (FTP) your custom graphics to your Guestbook NON CGI directory.
</FONT></TD>
</TR>
<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Guestbook Title Graphic:</B></FONT></td>
<td valign=top>
<INPUT TYPE="TEXT" NAME="GBTitlePic" VALUE="$GBTitlePic" SIZE=25 MAXLENGTH=50>
</td></tr>

<tr bgcolor="#f7f7f7">
<TD width=5 bgcolor="#000080">&nbsp;
</TD>
<td>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Add Entry Graphic:</B></FONT>
</td>
<td valign=top>
<INPUT TYPE="TEXT" NAME="AddEntryPic" VALUE="$AddEntryPic" SIZE=25 MAXLENGTH=50>
</td></tr>

</table>

<P>
<INPUT TYPE="HIDDEN" NAME="action" VALUE="sendstyles">

<CENTER>

<FONT COLOR="#FF0000" face="Verdana, Arial" Size="2"><B>Enter Passwords For This Guestbook</B></FONT>
<table border=0>
<TR>
<TD>
<FONT SIZE="2" FACE="Verdana, Arial"><B>Password #1</B></FONT>
</td>
<td><INPUT TYPE="password" NAME="password1" VALUE="$in{'password1'}" SIZE=25 MAXLENGTH=25>
</td>
<TR>
<td>
<B><FONT SIZE="2" FACE="Verdana, Arial">Password #2</FONT></B>
</td>
<td>
<INPUT TYPE="PASSWORD" NAME="password2" VALUE="$in{'password2'}" SIZE=25 MAXLENGTH=25>
</td>
</table>

<INPUT TYPE="SUBMIT" NAME="Submit" VALUE="Submit Style Changes Now">

</FORM>

<BR><BR><BR>

</CENTER>

<CENTER><FONT SIZE="1" FACE="Verdana, Arial" COLOR="#C0C0C0">Ultimate Guestbook<BR>&copy; Madrona Park, Inc., 1999.</FONT></CENTER>
</BODY>
</HTML>
Style12

}  # end EnterStyles sr


sub Colors {
print<<TheColors;
<OPTION value="" selected> Select New Color?
		<OPTION value="#ffffff" > White
        <OPTION value="#ff0000" > Red
        <OPTION value="#00ff00" > Green 
        <OPTION value="#0000ff" > Blue 
        <OPTION value="#ff00ff" > Magenta 
        <OPTION value="#00ffff" > Cyan
        <OPTION value="#ffff00" > Yellow 
        <OPTION value="#000000" > Black 
        <OPTION value="#70db93" > Aquamarine 
        <OPTION value="#a62a2a" > Brown 
        <OPTION value="#b87333" > Copper
        <OPTION value="#ff7f00" > Coral
        <OPTION value="#871f78" > Dark Purple
        <OPTION value="#97694f" > Dark Tan
        <OPTION value="#238e23" > Forest Green
        <OPTION value="#cd7f32" > Gold
        <OPTION value="#a8a8a8" > Grey
        <OPTION value="#9f9f5f" > Khaki
        <OPTION value="#c0d9d9" > Light Blue
		<OPTION value="#808000" > Light Copper
        <OPTION value="#cccccc" > Light Grey
        <OPTION value="#ffffcc" > Light Yellow
        <OPTION value="#32cd32" > Lime Green
        <OPTION value="#8e236b" > Maroon
        <OPTION value="#2f2f4f" > Midnight Blue
		<OPTION value="#000080" > Navy Blue
        <OPTION value="#ff7f00" > Orange
        <OPTION value="#8FBC8F" > Pale Green
        <OPTION value="#BC8F8F" > Pink
        <OPTION value="#E6E8fA" > Silver
        <OPTION value="#3299CC" > Sky Blue
		<OPTION value="#F7F7F7" > UBB Col1 Grey
		<OPTION value="#DEDFDF" > UBB Col2 Grey
        <OPTION value="#CC3299" > Violet
		<OPTION value="" > Other (type code)... 
			</SELECT>&nbsp;&nbsp;
TheColors
} # end colors sr


sub SendStyles {

if (-e "$GB_NON_CGI_Path/gbpassword.pl") {
	&CheckPW;
	if ($check eq "true") {
		&SetStyles;
	} else {
		&StandardHTML("Sorry, did not enter the correct passwords.  We cannot process your variables until this is corrected.  Use your back button to try again.");
	}
		}  else {
	&StandardHTML("You don't seem to have set your guestbook passwords. Please reset them by accessing your General Variables.  <A HREF=\"gbadmin.cgi?action=genvars\">Click here.</A>");	
			
}

}  ##END Set Gen Vars

sub SetStyles {
## don't allow bgcolor and copyright color to be the same

if ($in{'BGColor'} eq "$in{'CopyrightTextColor'}") {
	$in{'CopyrightTextColor'} = "$in{'TextColor'}";
}
open (FILE, ">$VariablesPath/gb_styles.pl") or die("Unable to open setup file for writing.");

foreach $one(@in) {
	($Name, $Value) = split ("=", $one);
	$Name = &decodeURL($Name);
	$Value = &decodeURL($Value);
	$Value =~ s/\@/\\@/g;
	$Value =~ s/"/\\"/g;
	print FILE ("\$$Name = \"$Value\";\n");
}

	print FILE ("1;\n");
close (FILE);
chmod (0777, "$VariablesPath/gb_styles.pl");
&StandardHTML("Thank you!  Your style variables have been set!");

}  #end SendStyles sr
